﻿using SoapEndpoint.Service.Proxy.Models.Flows;
using SoapEndpoint.Tester.Models.Flow;

namespace SoapEndpoint.Tester.Infrastructure;

public static class FlowDefinitions
{
    public static FlowDefinition[] Definitions { get; } =
    {
        SchuldBemiddelingFlow,
        SbEnSkFlow,
        WaarborgfondsFlow,
        InventarisatieFlow,
        BrEnHfFlow,
        BewindvoeringFlow,
        PauzeSignaal3Flow,
        ShvSignaalFlow
    };

    public static FlowDefinition SchuldBemiddelingFlow => new()
    {
        FlowType = FlowType.Schuldbemiddeling,
        SupportedVersions = new[]
        {
            new Version("1.0"),
            new Version("1.1")
        }
    };

    public static FlowDefinition SbEnSkFlow => new()
    {
        FlowType = FlowType.SbEnSk,
        SupportedVersions = new[]
        {
            new Version("1.0")
        }
    };

    public static FlowDefinition WaarborgfondsFlow => new()
    {
        FlowType = FlowType.Waarborgfonds,
        SupportedVersions = new[]
        {
            new Version("1.0")
        }
    };

    public static FlowDefinition InventarisatieFlow => new()
    {
        FlowType = FlowType.Inventarisatie,
        SupportedVersions = new[]
        {
            new Version("1.0")
        }
    };

    public static FlowDefinition BrEnHfFlow => new()
    {
        FlowType = FlowType.BrEnHf,
        SupportedVersions = new[]
        {
            new Version("1.0")
        }
    };

    public static FlowDefinition BewindvoeringFlow => new()
    {
        FlowType = FlowType.Bewindvoering,
        SupportedVersions = new[]
        {
            new Version("1.0")
        }
    };

    public static FlowDefinition PauzeSignaal3Flow => new()
    {
        FlowType = FlowType.PauzeSignaal3,
        SupportedVersions = new[]
        {
            new Version("1.0")
        }
    };

    public static FlowDefinition ShvSignaalFlow => new()
    {
        FlowType = FlowType.ShvSignaal,
        SupportedVersions = new[]
        {
            new Version("1.0")
        }
    };

    public static Version[] VersionsForFlowType(FlowType flowType)
    {
        return Definitions.Single(x => x.FlowType == flowType).SupportedVersions;
    }

    public static Version[] MajorVersionForFlowType(FlowType flowType)
    {
        return VersionsForFlowType(flowType).Where(x => x.Minor == 0).ToArray();
    }
}