﻿using SoapEndpoint.Service.Flows.PauzeSignaal3.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.PauzeSignaal3;

namespace SoapEndpoint.Tester.Scenario.Implementations.PauzeSignaal3;

public class HappyFlowScenario : PauzeSignaal3ScenarioBase
{
    public override string Name => "Happy flow scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Happy flow 1");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Happy flow 2");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving),
            new ShvFlowItem(BerichtType.SHV_Vervolgtraject));

        StartNewScenario("Happy flow 3");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_GeenMedewerking));

        StartNewScenario("Happy flow 4");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_KennisgevingAntwoord),
            new ShvFlowItem(BerichtType.SHV_Beeindiging));

        StartNewScenario("Happy flow 5");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_KennisgevingAntwoord),
            new ShvFlowItem(BerichtType.SHV_Vervolgtraject));
    }
}