﻿using SoapEndpoint.Service.Flows.PauzeSignaal3.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.PauzeSignaal3;

namespace SoapEndpoint.Tester.Scenario.Implementations.PauzeSignaal3;

public class ReminderScenario : PauzeSignaal3ScenarioBase
{
    public override string Name => "Reminder scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Scenario 1");

        var result = await Manager.SHV_RequestReplyAsync(Conversation, new ShvFlowItem(BerichtType.SHV_Kennisgeving));
        await Manager.SHV_RequestReplyAsync(Conversation, new ShvFlowItem(BerichtType.SHV_ReminderBericht),
            result.RequestMessage);

        StartNewScenario("Scenario 2");

        var result2 = await Manager.SHV_RequestReplyAsync(Conversation,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_KennisgevingAntwoord));

        await Manager.SHV_RequestReplyAsync(Conversation, new ShvFlowItem(BerichtType.SHV_ReminderBericht),
            result2.RequestMessage);
    }
}