using SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;
using SoapEndpoint.Tester.Scenario.Flow.SbEnSk;

namespace SoapEndpoint.Tester.Scenario.Implementations.SbEnSk;

public class SeSectorNutsScenario : SbEnSkScenarioBase
{
    public override string Name => "SE sector nuts scenario";

    public override AdresboekOrganisatieModel SeOrganization =>
        Manager.Organizations.SingleOrDefault(p => p.Referentienummer.ToString()
            .Equals(Program.Configuration["SeUtilityCompanyTestOrganizationReference"],
                StringComparison.CurrentCultureIgnoreCase));

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Happy flow - Regeling geaccordeerd 1");
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_KennisgevingAntwoord),
            new ShvFlowItem(BerichtType.SHV_SaldoverzoekNuts, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Happy flow - Regeling geaccordeerd 2");
        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_SaldoverzoekNuts, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Foutsituatie kennisgeving");
        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_KennisgevingPubliek, null,
            ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);

        StartNewScenario("Foutsituatie: saldoverzoek");
        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_Saldoverzoek, null,
            ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);
    }
}