﻿using SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;

namespace SoapEndpoint.Tester.Scenario.Implementations.SbEnSk;

public class SeSectorStandaardScenario : SbEnSkScenarioBase
{
    public override string Name => "Se Sector Standaard";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Foutsituatie kennisgeving");
        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_KennisgevingPubliek, null,
            ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);

        await SendInvalidSaldoverzoek();
    }

    private async Task SendInvalidSaldoverzoek()
    {
        var messageTypes = new List<BerichtType>
        {
            BerichtType.SHV_SaldoverzoekPubliek,
            BerichtType.SHV_SaldoverzoekNuts,
            BerichtType.SHV_SaldoverzoekZorg
        };

        foreach (var messageType in messageTypes)
        {
            StartNewScenario($"Foutsituatie: {messageType}");

            await Manager.SHV_SendIncorrectMessageAsync(Conversation, messageType, null,
                ShvKnooppuntFoutcode.Incorrectberichttypevoorsectorvanontvanger);
        }
    }
}