﻿using SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.SbEnSk;

namespace SoapEndpoint.Tester.Scenario.Implementations.SbEnSk;

public class StatusberichtStatusverzoek : SbEnSkScenarioBase
{
    public override string Name => "Statusbericht / statusverzoek";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Scenario 1");

        await Manager.SHV_RequestReplyAsync(Conversation, new ShvFlowItem(BerichtType.SHV_Kennisgeving));

        await Manager.SE_RequestReplyAsync(Conversation,
            new SeFlowItem(BerichtType.SE_Statusverzoek, BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));

        StartNewScenario("Scenario 2");

        await Manager.SHV_RequestReplyAsync(Conversation,
            new ShvFlowItem(BerichtType.SHV_Kennisgeving, BerichtType.SE_KennisgevingAntwoord));

        await Manager.SE_RequestReplyAsync(Conversation,
            new SeFlowItem(BerichtType.SE_Statusverzoek, BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));

        StartNewScenario("Scenario 3");

        await Manager.SHV_RequestReplyAsync(Conversation, new ShvFlowItem(BerichtType.SHV_Saldoverzoek));

        await Manager.SHV_RequestReplyAsync(Conversation, new ShvFlowItem(BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));

        StartNewScenario("Scenario 4");

        await Manager.SHV_RequestReplyAsync(Conversation,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord));

        await Manager.SE_RequestReplyAsync(Conversation,
            new SeFlowItem(BerichtType.SE_Statusverzoek, BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));

        StartNewScenario("Scenario 5");

        await Manager.SHV_RequestReplyAsync(Conversation,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoordVoorafAkkoord));

        await Manager.SE_RequestReplyAsync(Conversation,
            new SeFlowItem(BerichtType.SE_Statusverzoek, BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));

        StartNewScenario("Scenario 6");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel)
        );

        await Manager.SE_RequestReplyAsync(Conversation,
            new SeFlowItem(BerichtType.SE_Statusverzoek, BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));

        StartNewScenario("Scenario 7");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord)
        );

        await Manager.SE_RequestReplyAsync(Conversation,
            new SeFlowItem(BerichtType.SE_Statusverzoek, BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));

        StartNewScenario("Scenario 8");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek, BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordNietAkkoord)
        );

        await Manager.SE_RequestReplyAsync(Conversation,
            new SeFlowItem(BerichtType.SE_Statusverzoek, BerichtType.SHV_StatusberichtShv));

        await Manager.SE_RequestReplyAsync(Conversation, new SeFlowItem(BerichtType.SE_StatusberichtSe));
    }
}