using SoapEndpoint.Service.Flows.Waarborgfonds.v1.LogbookService;
using SoapEndpoint.Tester.Scenario.Flow.Waarborgfonds;

namespace SoapEndpoint.Tester.Scenario.Implementations.Waarborgfonds;

public class OtherScenarios : WaarborgfondsScenarioBase
{
    public override string Name => "Overige";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Saneringkrediet Informatie Aanvraag");
        await Manager.SE_FlowAsync(Conversation, null,
            new SeFlowItem(BerichtType.SE_SaneringskredietInformatieAanvraag,
                BerichtType.SHV_VerwerkSaneringskredietenInformatie, false));

        StartNewScenario("Borgstelling ingetrokken");
        await Manager.SE_FlowAsync(Conversation, null, new SeFlowItem(BerichtType.SE_BorgstellingIngetrokken));

        StartNewScenario("Waarborgfonds Foutbericht");

        // Send SHV message
        await Manager.SHV_FlowAsync(Conversation, null, new ShvFlowItem(BerichtType.SHV_AanvraagBorgstelling));

        // Send Foutbericht
        await Manager.SE_FlowAsync(Conversation, null, new SeFlowItem(BerichtType.SE_WaarborgfondsFoutbericht, false));

        // Send another SHV message
        await Manager.SHV_FlowAsync(Conversation, null, new ShvFlowItem(BerichtType.SHV_AanvraagBorgstelling));
    }
}