﻿using SoapEndpoint.Service.Proxy.Models.Flows;

namespace SoapEndpoint.Tester.Scenario;

public class ScenarioResult
{
    public ScenarioResult(ScenarioBase scenario, string name, FlowType flowType)
    {
        Name = name;
        Scenario = scenario;
        Conversation = new Conversation(flowType);
    }

    public string Name { get; set; }
    public ScenarioBase Scenario { get; }
    public Conversation Conversation { get; }
    public bool Success => string.IsNullOrEmpty(Error);
    public string Error { get; set; }

    public void SetError(string error)
    {
        Error = error;
    }
}