﻿using AutoMapper;
using SoapEndpoint.Service.Proxy.Models.Flows;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;
using SoapEndpoint.Service.Systeem.v2.AddressService;
using SoapEndpoint.Service.Systeem.v2.MessageBoxService;
using BerichtExtensieType = SoapEndpoint.Service.Proxy.Models.Systeem.BerichtExtensieType;
using BrEnHfLogbookServiceV1 = SoapEndpoint.Service.Flows.BrEnHf.v1.LogbookService;
using BrEnHfMessageType = SoapEndpoint.Service.Flows.BrEnHf.v1.LogbookService.BerichtType;
using BrEnHfSeServiceV1 = SoapEndpoint.Service.Flows.BrEnHf.v1.SeService;
using BrEnHfShvServiceV1 = SoapEndpoint.Service.Flows.BrEnHf.v1.ShvService;
using InventarisatieLogbookServiceV1 = SoapEndpoint.Service.Flows.Inventarisatie.v1.LogbookService;
using InventarisatieMessageType = SoapEndpoint.Service.Flows.Inventarisatie.v1.LogbookService.BerichtType;
using InventarisatieSeServiceV1 = SoapEndpoint.Service.Flows.Inventarisatie.v1.SeService;
using InventarisatieShvServiceV1 = SoapEndpoint.Service.Flows.Inventarisatie.v1.ShvService;
using SbEnSkLogbookServiceV1 = SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService;
using SbEnSkMessageType = SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService.BerichtType;
using SbEnSkSeServiceV1 = SoapEndpoint.Service.Flows.SbEnSk.v1.SeService;
using SbEnSkShvServiceV1 = SoapEndpoint.Service.Flows.SbEnSk.v1.ShvService;
using SchuldbemiddelingMessageType = SoapEndpoint.Service.Systeem.v1.LogbookService.Berichttype;
using SchuldBemiddelingSeServiceV1 = SoapEndpoint.Service.Flows.Schuldbemiddeling.v1.SeService;
using SchuldBemiddelingShvServiceV1 = SoapEndpoint.Service.Flows.Schuldbemiddeling.v1.ShvService;
using WaarborgfondsLogbookServiceV1 = SoapEndpoint.Service.Flows.Waarborgfonds.v1.LogbookService;
using WaarborgfondsMessageType = SoapEndpoint.Service.Flows.Waarborgfonds.v1.LogbookService.BerichtType;
using WaarborgfondsSeServiceV1 = SoapEndpoint.Service.Flows.Waarborgfonds.v1.SeService;
using WaarborgfondsShvServiceV1 = SoapEndpoint.Service.Flows.Waarborgfonds.v1.ShvService;
using BewindvoeringLogbookServiceV1 = SoapEndpoint.Service.Flows.Bewindvoering.v1.LogbookService;
using BewindvoeringMessageType = SoapEndpoint.Service.Flows.Bewindvoering.v1.LogbookService.BerichtType;
using BewindvoeringSeServiceV1 = SoapEndpoint.Service.Flows.Bewindvoering.v1.SeService;
using BewindvoeringShvServiceV1 = SoapEndpoint.Service.Flows.Bewindvoering.v1.ShvService;
using PauzeSignaal3LogbookServiceV1 = SoapEndpoint.Service.Flows.PauzeSignaal3.v1.LogbookService;
using PauzeSignaal3MessageType = SoapEndpoint.Service.Flows.PauzeSignaal3.v1.LogbookService.BerichtType;
using PauzeSignaal3SeServiceV1 = SoapEndpoint.Service.Flows.PauzeSignaal3.v1.SeService;
using PauzeSignaal3ShvServiceV1 = SoapEndpoint.Service.Flows.PauzeSignaal3.v1.ShvService;
using ShvSignaalLogbookServiceV1 = SoapEndpoint.Service.Flows.ShvSignaal.v1.LogbookService;
using ShvSignaalMessageType = SoapEndpoint.Service.Flows.ShvSignaal.v1.LogbookService.BerichtType;
using ShvSignaalShvServiceV1 = SoapEndpoint.Service.Flows.ShvSignaal.v1.ShvService;
using Contactpersoon = SoapEndpoint.Service.Systeem.v2.AddressService.Contactpersoon;
using DownloadBijlage = SoapEndpoint.Service.Systeem.v2.MessageBoxService.DownloadBijlage;
using MessageboxBericht = SoapEndpoint.Service.Systeem.v2.MessageBoxService.MessageboxBericht;
using MessageboxBerichtinformatie = SoapEndpoint.Service.Systeem.v2.MessageBoxService.MessageboxBerichtinformatie;
using MessageboxConfirmatieBericht = SoapEndpoint.Service.Systeem.v2.MessageBoxService.MessageboxConfirmatieBericht;
using MessageboxConfirmatieResultBericht =
    SoapEndpoint.Service.Systeem.v2.MessageBoxService.MessageboxConfirmatieResultBericht;
using UpdateOrganisatieBericht = SoapEndpoint.Service.Systeem.v2.AddressService.UpdateOrganisatieBericht;

namespace SoapEndpoint.Service.Proxy;

public class MappingProfileV2 : Profile
{
    public MappingProfileV2()
    {
        #region system

        CreateMap<UpdateOrganisatieBericht, UpdateOrganisatieBerichtModel>()
            .ForMember(o => o.OndersteundeVersies, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<AdresboekZoekbericht, AdresboekZoekBerichtModel>().ReverseMap();
        CreateMap<AdresboekOrganisatie, AdresboekOrganisatieModel>().ReverseMap();
        CreateMap<Adres, AdresModel>().ReverseMap();
        CreateMap<Contactpersoon, ContactpersoonModel>().ReverseMap();
        CreateMap<Flow, OrganizationFlowModel>()
            .ForMember(x => x.OrganisatieFlowType, opt
                => opt.MapFrom(p => Enum.Parse(typeof(FlowType), p.OrganisatieFlowType)))
            .ReverseMap();

        CreateMap<MessageboxConfirmatieBericht, MessageboxConfirmatieBerichtModel>().ReverseMap();
        CreateMap<MessageboxConfirmatieResultBericht, MessageboxConfirmatieResultBerichtModel>()
            .ReverseMap();
        CreateMap<MessageboxBerichtinformatie, MessageboxBerichtinformatieModel>().ReverseMap();
        CreateMap<MessageboxBericht, MessageboxBerichtModel>().ReverseMap();
        CreateMap<DownloadBijlage, DownloadBijlageModel>().ReverseMap();

        CreateMap<Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType,
                opt => opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, Bijlage>()
            .ForMember(x => x.BerichtExtensieType,
                opt => opt.MapFrom(p =>
                    (Systeem.v2.MessageBoxService.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<ShvKnooppuntFoutbericht, ShvKnooppuntFoutberichtModel>().ReverseMap();
        CreateMap<ShvKnooppuntFout, ShvKnooppuntFoutModel>().ReverseMap();

        #endregion

        #region schuldbemiddeling

        CreateMap<SchuldBemiddelingShvServiceV1.BerichtHeaderSHV, BerichtHeaderModel>()
            .ForMember(x => x.Bijlages, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<SchuldBemiddelingShvServiceV1.ShvBericht, BerichtModel<SchuldbemiddelingMessageType>>().ReverseMap();
        CreateMap<SchuldBemiddelingShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<SchuldBemiddelingShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<SchuldBemiddelingSeServiceV1.BerichtHeaderSE, BerichtHeaderModel>()
            .ForMember(x => x.Ontvanger, cfg => cfg.Ignore())
            .ForMember(x => x.Bijlages, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<SchuldBemiddelingSeServiceV1.SeBericht, BerichtModel<SchuldbemiddelingMessageType>>().ReverseMap();
        CreateMap<SchuldBemiddelingSeServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<SchuldBemiddelingSeServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        #endregion

        #region SbEnSk

        CreateMap<SbEnSkShvServiceV1.BerichtHeaderSHV, BerichtHeaderModel>().ReverseMap();

        CreateMap<SbEnSkShvServiceV1.Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, SbEnSkShvServiceV1.Bijlage>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (SbEnSkShvServiceV1.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<SbEnSkShvServiceV1.ShvBericht, BerichtModel<SbEnSkMessageType>>().ReverseMap();
        CreateMap<SbEnSkShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<SbEnSkShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>().ReverseMap();

        CreateMap<SbEnSkSeServiceV1.BerichtHeaderSE, BerichtHeaderModel>()
            .ForMember(x => x.Ontvanger, cfg => cfg.Ignore())
            .ForMember(x => x.Bijlages, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<SbEnSkSeServiceV1.SeBericht, BerichtModel<SbEnSkMessageType>>().ReverseMap();
        CreateMap<SbEnSkSeServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<SbEnSkSeServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>().ReverseMap();

        CreateMap<SbEnSkLogbookServiceV1.LogboekZoekbericht, LogboekZoekberichtModel>().ReverseMap();
        CreateMap<SbEnSkLogbookServiceV1.LogboekBericht, LogboekBerichtModel<SbEnSkMessageType>>().ReverseMap();
        CreateMap<SbEnSkLogbookServiceV1.ConversatieLogboekZoekbericht, ConversatieLogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<SbEnSkLogbookServiceV1.ConversatieLogboekBericht, ConversatieLogboekBerichtModel<SbEnSkMessageType>>()
            .ForMember(x => x.Staat, opt
                => opt.MapFrom(p => p.Staat.ToString()))
            .ReverseMap();

        #endregion

        #region Waarborgfonds

        CreateMap<WaarborgfondsSeServiceV1.BerichtHeaderWaarborgfonds, BerichtHeaderModel>().ReverseMap();

        CreateMap<WaarborgfondsSeServiceV1.Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, WaarborgfondsSeServiceV1.Bijlage>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (WaarborgfondsSeServiceV1.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<WaarborgfondsSeServiceV1.SeBericht, BerichtModel<WaarborgfondsMessageType>>().ReverseMap();
        CreateMap<WaarborgfondsSeServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<WaarborgfondsSeServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<WaarborgfondsShvServiceV1.BerichtHeaderKredietbankWaarborgfonds, BerichtHeaderModel>()
            .ForMember(x => x.Ontvanger, opt => opt.Ignore())
            .ForMember(x => x.CrossReferentienummer, opt => opt.Ignore())
            .ForMember(x => x.Bijlages, opt => opt.Ignore())
            .ReverseMap();
        CreateMap<WaarborgfondsShvServiceV1.ShvBericht, BerichtModel<WaarborgfondsMessageType>>().ReverseMap();
        CreateMap<WaarborgfondsShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<WaarborgfondsShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<WaarborgfondsLogbookServiceV1.LogboekZoekbericht, LogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<WaarborgfondsLogbookServiceV1.LogboekBericht, LogboekBerichtModel<WaarborgfondsMessageType>>()
            .ReverseMap();
        CreateMap<WaarborgfondsLogbookServiceV1.ConversatieLogboekZoekbericht, ConversatieLogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<WaarborgfondsLogbookServiceV1.ConversatieLogboekBericht,
                ConversatieLogboekBerichtModel<WaarborgfondsMessageType>>()
            .ForMember(x => x.Staat, opt => opt.MapFrom(p => p.Staat.ToString()))
            .ReverseMap();

        #endregion

        #region Inventarisatie

        CreateMap<InventarisatieShvServiceV1.BerichtHeaderSHV, BerichtHeaderModel>().ReverseMap();

        CreateMap<InventarisatieShvServiceV1.Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, InventarisatieShvServiceV1.Bijlage>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (InventarisatieShvServiceV1.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<InventarisatieShvServiceV1.ShvBericht, BerichtModel<InventarisatieMessageType>>().ReverseMap();
        CreateMap<InventarisatieShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<InventarisatieShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<InventarisatieSeServiceV1.BerichtHeaderSE, BerichtHeaderModel>()
            .ForMember(x => x.Ontvanger, cfg => cfg.Ignore())
            .ForMember(x => x.Bijlages, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<InventarisatieSeServiceV1.SeBericht, BerichtModel<InventarisatieMessageType>>().ReverseMap();
        CreateMap<InventarisatieSeServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<InventarisatieSeServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<InventarisatieLogbookServiceV1.LogboekZoekbericht, LogboekZoekberichtModel>().ReverseMap();
        CreateMap<InventarisatieLogbookServiceV1.LogboekBericht, LogboekBerichtModel<InventarisatieMessageType>>()
            .ReverseMap();
        CreateMap<InventarisatieLogbookServiceV1.ConversatieLogboekZoekbericht, ConversatieLogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<InventarisatieLogbookServiceV1.ConversatieLogboekBericht,
                ConversatieLogboekBerichtModel<InventarisatieMessageType>>()
            .ForMember(x => x.Staat, opt
                => opt.MapFrom(p => p.Staat.ToString()))
            .ReverseMap();

        #endregion

        #region BrEnHf

        CreateMap<BrEnHfShvServiceV1.BerichtHeaderSHV, BerichtHeaderModel>().ReverseMap();

        CreateMap<BrEnHfShvServiceV1.Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, BrEnHfShvServiceV1.Bijlage>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BrEnHfShvServiceV1.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BrEnHfShvServiceV1.ShvBericht, BerichtModel<BrEnHfMessageType>>().ReverseMap();
        CreateMap<BrEnHfShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<BrEnHfShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>().ReverseMap();

        CreateMap<BrEnHfSeServiceV1.BerichtHeaderSE, BerichtHeaderModel>()
            .ForMember(x => x.Ontvanger, cfg => cfg.Ignore())
            .ForMember(x => x.Bijlages, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<BrEnHfSeServiceV1.SeBericht, BerichtModel<BrEnHfMessageType>>().ReverseMap();
        CreateMap<BrEnHfSeServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<BrEnHfSeServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>().ReverseMap();

        CreateMap<BrEnHfLogbookServiceV1.LogboekZoekbericht, LogboekZoekberichtModel>().ReverseMap();
        CreateMap<BrEnHfLogbookServiceV1.LogboekBericht, LogboekBerichtModel<BrEnHfMessageType>>().ReverseMap();
        CreateMap<BrEnHfLogbookServiceV1.ConversatieLogboekZoekbericht, ConversatieLogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<BrEnHfLogbookServiceV1.ConversatieLogboekBericht, ConversatieLogboekBerichtModel<BrEnHfMessageType>>()
            .ForMember(x => x.Staat, opt
                => opt.MapFrom(p => p.Staat.ToString()))
            .ReverseMap();

        #endregion

        #region Bewindvoering

        CreateMap<BewindvoeringShvServiceV1.BerichtHeaderSHV, BerichtHeaderModel>().ReverseMap();

        CreateMap<BewindvoeringShvServiceV1.Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, BewindvoeringShvServiceV1.Bijlage>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BewindvoeringShvServiceV1.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BewindvoeringShvServiceV1.ShvBericht, BerichtModel<BewindvoeringMessageType>>().ReverseMap();
        CreateMap<BewindvoeringShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<BewindvoeringShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<BewindvoeringSeServiceV1.BerichtHeaderSE, BerichtHeaderModel>()
            .ForMember(x => x.Ontvanger, cfg => cfg.Ignore())
            .ForMember(x => x.Bijlages, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<BewindvoeringSeServiceV1.SeBericht, BerichtModel<BewindvoeringMessageType>>().ReverseMap();
        CreateMap<BewindvoeringSeServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<BewindvoeringSeServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<BewindvoeringLogbookServiceV1.LogboekZoekbericht, LogboekZoekberichtModel>().ReverseMap();
        CreateMap<BewindvoeringLogbookServiceV1.LogboekBericht, LogboekBerichtModel<BewindvoeringMessageType>>()
            .ReverseMap();
        CreateMap<BewindvoeringLogbookServiceV1.ConversatieLogboekZoekbericht, ConversatieLogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<BewindvoeringLogbookServiceV1.ConversatieLogboekBericht,
                ConversatieLogboekBerichtModel<BewindvoeringMessageType>>()
            .ForMember(x => x.Staat, opt
                => opt.MapFrom(p => p.Staat.ToString()))
            .ReverseMap();

        #endregion

        #region PauzeSignaal3

        CreateMap<PauzeSignaal3ShvServiceV1.BerichtHeaderSHV, BerichtHeaderModel>().ReverseMap();

        CreateMap<PauzeSignaal3ShvServiceV1.Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, PauzeSignaal3ShvServiceV1.Bijlage>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (PauzeSignaal3ShvServiceV1.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<PauzeSignaal3ShvServiceV1.ShvBericht, BerichtModel<PauzeSignaal3MessageType>>().ReverseMap();
        CreateMap<PauzeSignaal3ShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<PauzeSignaal3ShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<PauzeSignaal3SeServiceV1.BerichtHeaderSE, BerichtHeaderModel>()
            .ForMember(x => x.Ontvanger, cfg => cfg.Ignore())
            .ForMember(x => x.Bijlages, cfg => cfg.Ignore())
            .ReverseMap();
        CreateMap<PauzeSignaal3SeServiceV1.SeBericht, BerichtModel<PauzeSignaal3MessageType>>().ReverseMap();
        CreateMap<PauzeSignaal3SeServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<PauzeSignaal3SeServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>()
            .ReverseMap();

        CreateMap<PauzeSignaal3LogbookServiceV1.LogboekZoekbericht, LogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<PauzeSignaal3LogbookServiceV1.LogboekBericht, LogboekBerichtModel<PauzeSignaal3MessageType>>()
            .ReverseMap();
        CreateMap<PauzeSignaal3LogbookServiceV1.ConversatieLogboekZoekbericht, ConversatieLogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<PauzeSignaal3LogbookServiceV1.ConversatieLogboekBericht,
                ConversatieLogboekBerichtModel<PauzeSignaal3MessageType>>()
            .ForMember(x => x.Staat, opt
                => opt.MapFrom(p => p.Staat.ToString()))
            .ReverseMap();

        #endregion

        #region ShvSignaal

        CreateMap<ShvSignaalShvServiceV1.BerichtHeaderSHV, BerichtHeaderModel>().ReverseMap();

        CreateMap<ShvSignaalShvServiceV1.Bijlage, BijlageModel>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<BijlageModel, ShvSignaalShvServiceV1.Bijlage>()
            .ForMember(x => x.BerichtExtensieType, opt =>
                opt.MapFrom(p => (ShvSignaalShvServiceV1.BerichtExtensieType)p.BerichtExtensieType));

        CreateMap<ShvSignaalShvServiceV1.ShvBericht, BerichtModel<ShvSignaalMessageType>>().ReverseMap();
        CreateMap<ShvSignaalShvServiceV1.ShvKnooppuntBerichtBevestiging, ShvKnooppuntBerichtBevestigingModel>()
            .ForMember(x => x.Errors, cfg
                => cfg.Ignore())
            .ForMember(x => x.ErrorCodes, cfg
                => cfg.Ignore())
            .ReverseMap();
        CreateMap<ShvSignaalShvServiceV1.ShvKnooppuntFout, ShvKnooppuntFoutModel>().ReverseMap();

        CreateMap<ShvSignaalLogbookServiceV1.LogboekZoekbericht, LogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<ShvSignaalLogbookServiceV1.LogboekBericht, LogboekBerichtModel<ShvSignaalMessageType>>()
            .ReverseMap();
        CreateMap<ShvSignaalLogbookServiceV1.ConversatieLogboekZoekbericht, ConversatieLogboekZoekberichtModel>()
            .ReverseMap();
        CreateMap<ShvSignaalLogbookServiceV1.ConversatieLogboekBericht,
                ConversatieLogboekBerichtModel<ShvSignaalMessageType>>()
            .ForMember(x => x.Staat, opt
                => opt.MapFrom(p => p.Staat.ToString()))
            .ReverseMap();

        #endregion
    }
}