﻿using AutoMapper;
using SoapEndpoint.Service.Flows.BrEnHf.v1.LogbookService;
using SoapEndpoint.Service.Proxy.Models.Systeem;

namespace SoapEndpoint.Service.Proxy.ServiceProxies.Flows.BrEnHf.v1;

public class LogbookProxy : ILogbookProxy<BerichtType>
{
    private readonly IMapper _mapper;

    private readonly
        ISoapLogbookServiceOf_LogboekBericht_LogboekZoekbericht_ConversatieLogboekBericht_ConversatieLogboekZoekbericht
        _service;

    public LogbookProxy(IMapper mapper,
        ISoapLogbookServiceOf_LogboekBericht_LogboekZoekbericht_ConversatieLogboekBericht_ConversatieLogboekZoekbericht
            service)
    {
        _mapper = mapper;
        _service = service;
    }

    public async Task<ConversatieLogboekBerichtModel<BerichtType>> GetConversationAsync(
        ConversatieLogboekZoekberichtModel bericht)
    {
        var request = _mapper.Map<ConversatieLogboekZoekbericht>(bericht);
        var response = await _service.GetConversationAsync(request);
        return _mapper.Map<ConversatieLogboekBerichtModel<BerichtType>>(response);
    }

    public async Task<LogboekBerichtModel<BerichtType>[]> GetMessagesAsync(LogboekZoekberichtModel bericht)
    {
        var request = _mapper.Map<LogboekZoekbericht>(bericht);
        var response = await _service.GetMessagesAsync(request);
        return _mapper.Map<LogboekBerichtModel<BerichtType>[]>(response);
    }
}